{$IFDEF MSDOS}
  {$IFNDEF DPMI}
  {$IFNDEF DPMI32}
    {$DEFINE RealMode}
    {$O+}
  {$ENDIF}
  {$ENDIF}
{$ENDIF}
{$F+,I-}
{&Delphi+}

Unit Shell;

{*********************************************************}
{*                       SHELL.PAS                       *}
{*                                                       *}
{*  Copyright (c) Alex Radzishevskiy, 1995-96,           *}
{*   Portions (c) Konstantin Klyagin, 1996-98,           *}
{*                exspecially for Tornado BBS System     *}
{*                                                       *}
{*********************************************************}

Interface

Procedure InitShellUnit;

Implementation

Uses
{$IFDEF RealMode}
  ExecSwap,
{$ENDIF}

{$IFDEF WIN32}
  ApWin32,
{$ENDIF}

{$IFDEF OS2}
  Os2PmApi,
  Os2Def,
  Os2Base,
  VPUtils,
{$ENDIF}

  ApSame,
  DOS,
  tWin,
  tMisc,
  Log,
  OpCrt,
  SysMsgs,
  TGlob,
  Doors;

Function fDosShell (Prg: String; CommandCom, LogErrorLevel: Boolean): Word;
{$IFDEF RealMode}
Var
  SwapLoc : Array [Boolean] Of String [20];
{$ENDIF}

  Procedure ExecPrepare;
  Begin
    {$IFDEF RealMode}
    WriteLn (' ' + sm (smSwapReserved), BytesSwapped, sm (smBytes), ' ',
      SwapLoc [EmsAllocated]);
    {$ENDIF}

    WriteLn (' ' + sm (smGenInfo));
    WriteLn;

    If Not Registering Then
    Begin
      DorinfoGen;
      DoorSysGen;
      ExitInfoGen;
    End;
  End;

Var
  i                           : Integer;
  Status                      : Word;
  Covers                      : Pointer;
  oxx, oxy, Attr              : Byte;
  ExeExt                      : String [12];
  ExeName, Parameters, CurDir : String;

Begin
  ExeName := ExtractAscii (1, Prg, SpaceOnly, '"');
  ExeExt := UpString (JustExtension (ExeName));
  CommandCom := CommandCom Or ((ExeExt <> 'EXE') And (ExeExt <> 'COM'));

  If CommandCom Then
  Begin
    If Prg <> '' Then
      Prg := '/c ' + Prg;
  End Else
  Begin
    i := AsciiPosition (2, Prg, SpaceOnly, '"');
    If i > 0 Then Parameters := Copy (Prg, i, 255)
             Else Parameters := '';
  End;

  Attr := TextAttr;
  TextAttr := $07;
  oxx := WhereX;
  oxy := WhereY;
  Status := 0;

  SaveWindow (1, 1, ScrX + 1, ScrY + 1, True, Covers);
  Window (1, 1, ScrX + 1, ScrY + 1);
  ClrScr;
  GetDir (0, CurDir);

{$IFDEF MSDOS}

{$IFDEF RealMode}
  SwapLoc [True]  := sm (smSwapEMS);
  SwapLoc [False] := sm (smSwapDisk);
  UseEmsIfAvailable := False;

  If Not InitExecSwap (HeapPtr, Cnf. TempDir + DelChars ([':'], StrTime) +
     'sw' + LineExt) Then
  Begin
    WriteLn (' ' + sm (smSwapError));
    LogWrite ('!', sm (smSwapError));
    If Cnf. Sound Then
      SoundOf ('1 200 1 2 800 1000 -1 2 800');
  End Else
{$ENDIF}
  Begin
    ExecPrepare;
    If Not Local Then
      DeactivatePort (Port, True);
    SwapVectors;

    If CommandCom Then
    {$IFDEF RealMode}
      ExecWithSwap (GetEnv ('COMSPEC'), Prg)
    {$ELSE}
      Exec (GetEnv ('COMSPEC'), Prg)
    {$ENDIF}
    Else
    {$IFDEF RealMode}
      ExecWithSwap (ExeName, Parameters);
    {$ELSE}
      Exec (ExeName, Parameters);
    {$ENDIF}

    Status := DosExitCode;
    SwapVectors;
    If Not Local Then
      ActivatePort (Port, True);
  {$IFDEF RealMode}
    ShutdownExecSwap;
  {$ENDIF}
  End;

{$ELSE}
  ExecPrepare;
  If CommandCom Then Exec (GetEnv ('COMSPEC'), Prg)
                Else Exec (ExeName, Parameters);
  Status := DosExitCode;
{$ENDIF}

  fDosShell := Status;

  SmartChDir (CurDir);

  If Not CommandCom And LogErrorLevel Then
    LogWrite (':', sm (smErrorLevel) + Long2Str (Status));

  ReInitCrt;
  TextAttr := 0;
  ClrScr;
  RestoreWindow (1, 1, ScrX + 1, ScrY + 1, True, Covers);
  TWinInit;
  If StatusBar Then
    Window (1, 1, ScrX + 1, ScrY - 1);
  SetBlink (Cnf. Blinking);
  GotoXY (oxx, oxy);
  TextAttr := Attr;
End;

Function fTranslateExecParams (Const S: String): String;
Var
  i      : Integer;
  S1     : String;
{$IFNDEF VirtualPascal}
  Result : String;
{$ENDIF}

Begin
  If Not Local Then
  Begin
  {$IFNDEF OS2}
    S1 := Long2Str (Cnf. ComPort);
  {$ELSE}
    If Copy (Cnf. ComPort, 1, 3) = 'COM' Then
      S1 := Trim (Copy (Cnf. ComPort, 4, 255))
    Else
      S1 := '0';
  {$ENDIF}
  End
  Else
    S1 := '0';

  Result := PlaceSubStr (S, '*P', S1);

{$IFDEF OS2}
  If Not Local Then
    S1 := Long2Str (ApOS2. ComHandle)
  Else
    S1 := '0';
  PlaceSubStrP (Result, '*H', S1);
{$ENDIF}

{$IFDEF WIN32}
  If Not Local Then
    S1 := Long2Str (ApWin32. ComHandle)
  Else
    S1 := '0';
  PlaceSubStrP (Result, '*H', S1);
{$ENDIF}

  PlaceSubStrP (Result, '*N', Long2Str (BbsLine));
  PlaceSubStrP (Result, '*B', Long2Str (GetConnectSpeed));
  PlaceSubStrP (Result, '*G', ZeroOne [R. Emu in [teAnsi, teAvatar]]);
  PlaceSubStrP (Result, '*F', ExtractWord (1, R. Name, SpaceOnly));

  i := WordCount (R. Name, SpaceOnly);
  If i > 1 Then
    S1 := ExtractWord (i, R. Name, SpaceOnly)
  Else
    S1 := '';

  PlaceSubStrP (Result, '*L', S1);
{$IFNDEF VirtualPascal}
  fTranslateExecParams := PlaceSubStr
{$ELSE}
  PlaceSubStrP
{$ENDIF}
  (Result, '*T', Long2Str (Round ((R. TotalTime - TimeDiff (EnterTime, MidSec))
    / 60)));
End;

Procedure InitShellUnit;
Begin
  DosShell := fDosShell;
  TranslateExecParams := fTranslateExecParams;
End;

End.
